C    *******************************
C    *******************************
C    ***  UNTERPROGRAMM  BALK2  ****
C    *******************************
C    *******************************
C    DAS UNTERPROGRAMM BALK2 ERSTELLT DIE ES - MATRIX
C    FUER DAS STRUKTURELEMENT  EBENER BALKEN
C    ******************************************************
C    *    VERWENDETE VARIABLEN:                           *
C    *                                                    *
C    *    E     : ELASTIZITAETSMODUL                      *
C    *    AR    : QUERSCHNITTSFLAECHE                     *
C    *    TRZ   : FLAECHENTRAEGHEITSMOMENT BEZUEGLICH     *
C    *               DER LOKALEN Z-ACHSE                  *
C    *    XL;YL : KOORDINATENDIFFERENZEN                  *
C    *    CA;SA : RICHTUNGSCOSINUS ZU DEN GLOBALEN ACHSEN *
C    *                                                    *
C    *    VERWENDETE FELDER:                              *
C    *                                                    *
C    *    X     : KNOTENKOORDINATEN                       *
C    *    ELST  : ES-MATRIX                               *
C    ******************************************************
      SUBROUTINE BALK2 ( X, E , AR , TRZ  )
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER          FREI, ANZA
      DIMENSION        X (3,3)
C
      COMMON  /ES / ELST (12,12)
      COMMON  /PAR/ KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *              LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
      XL =   X(2,1)- X(1,1)
      YL =   X(2,2)- X(1,2)
C
C          LAENGE DES BALKENS
C
      STL  = ( XL**2 + YL**2 )**0.5
C
C         BESTIMMUNG DER RICHTUNGSCOSINUS
C
60    CA = XL / STL
      SA = YL / STL
C
80    FO = E * TRZ / STL**3
C
C         KONSTANTEN INNERHALB DER LOKALEN ES-MATRIX
C
      A11 = FO * AR * STL**2 / TRZ
      A22 = FO * 12
      A23 = FO * 6*STL
      A33 = FO * 4*STL**2
C
C         BESTIMMUNG DER ELEMENTE
C
      ELST (1,1) =  (A11*CA**2+A22*SA**2)
      ELST (1,4) = -ELST (1,1)
      ELST (4,4) =  ELST (1,1)
      ELST (1,2) =  CA*SA*( A11-A22 )
      ELST (1,5) = -ELST (1,2)
      ELST (2,4) =  ELST (1,5)
      ELST (4,5) =  ELST (1,2)
      ELST (1,3) = -A23*SA
      ELST (1,6) =  ELST (1,3)
      ELST (3,4) = -ELST (1,3)
      ELST (4,6) =  ELST (3,4)
      ELST (2,2) =  A11*SA**2 + A22*CA**2
      ELST (5,5) =  ELST (2,2)
      ELST (2,5) = -ELST (2,2)
      ELST (2,3) =  A23*CA
      ELST (3,5) = -ELST (2,3)
      ELST (5,6) =  ELST (3,5)
      ELST (2,6) =  ELST (2,3)
      ELST (3,3) =  A33
      ELST (6,6) =  A33
      ELST (3,6) =  A33/2.
C
      RETURN
      END
