C  ***************************************
C  ***************************************
C  ***        HAUPTPROGRAMM            ***
C  ***************************************
C  ***************************************
C  DAS HAUPTPROGRAMM LIEST DIE BEFEHLE AUS DER BEFEHLS-
C  DATEI, UEBERNIMMT DIE PARAMETERWERTE UND STEUERT
C  ENTSPRECHEND DEN AUFRUF DER UNTERPROGRAMME
C**********************************************************
C*  VERWENDETE VARIABLEN:                                 *
C*                                                        *
C*  TYP    : BELEGT MIT '*TYP'. DIENT DAZU, DEN BEFEHL    *
C*           *TYPEN ZU ERKENNEN.                          *
C*  DRU    : BELEGT MIT '*DRU'. DIENT DAZU, DEN BEFEHL    *
C*           *DRUCK  ZU ERKENNEN.                         *
C*  RELE   : BEZEICHNET DIE ART DER RECHENLEISTUNG        *
C*  AUST   : LITERAL-KONSTANTE, DIE DAS AUSDRUCKEN        *
C*           DER STRUKTUR STEUERT                         *
C*  AUVE   : LITERAL-KONSTANTE, DIE DAS AUSDRUCKEN DER    *
C*           DER VERSCHIEBUNGEN STEUERT                   *
C*  AUSP   : LITERAL-KONSTANTE, DIE DAS AUSDRUCKEN DER    *
C*           SPANNUNGEN STEUERT                           *
C*  AULA   : LITERALKONSTANTE, DIE DAS AUSDRUCKEN DER     *
C*           AUFLAGERREAKTIONEN STEUERT                   *
C*  PLOT   : LITERALKONSTANTE, DIE DAS RETTEN DER         *
C*           VERSCHIEBUNGEN IN DIE DATEI '99' ZUM         *
C*           SPAETEREN PLOTTEN STEUERT                    *
C*  ANZA   : ANZAHL DER EINZULESENDEN ELEMENTTYPEN        *
C*  KOANZ  : DIMENSION DES KOORDINATENSYSTEMS             *
C*  FREI   : ANZAHL DER FREIHEITSGRADE PRO KNOTEN         *
C*  MBAND  : BANDBREITE DER EINGEGEBENEN STRUKTUR         *
C*  MBA    : VOM PROGRAMM ZUGELASSENE BANDBREITE          *
C*  LGS    : LAENGE DER GS-MATRIX                         *
C*                                                        *
C*  VERWENDETE FELDER                                     *
C*                                                        *
C*  A      : NIMMT EINE ZEILE AUS DER DATEI '70' AUF      *
C*  ETYP   : ENTHAELT DIE EINGELESENEN ELEMENTTYPEN       *
C*  D      : ENTHAELT SPAETER DIE FUER DAS CHOLESKY-      *
C*           VERFAHREN BENOETIGTE "DREIECKSMATRIX" AUS    *
C*           DEM BAND DER GS-MATRIX                       *
C*  LAD    : LAENGE VON D                                 *
C*  V      : ENTHAELT SPAETER DEN BELASTUNGSVEKTOR        *
C*           UND DANN DIE VERSCHIEBUNGEN                  *
C*  LAV    : LAENGE VON V                                 *
C*  XKN    : FELD DER KNOTENKOORDINATEN                   *
C*  LAX    : LAENGE VON XKN                               *
C**********************************************************
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER  ANZA,FREI
      CHARACTER*4 BEF,DRU,TYP
      CHARACTER RELE,AUST,AUVE,AUSP,AULA,PLOT,NT,JA
      CHARACTER*2 NAME,NARA
      COMMON /FELD/  A(110),D(6105),V(500),XKN(500)
      COMMON /REFE/  REF(10,7)
      COMMON /RAND/  KNRA(50),RV(50,6),AUFL(50,6)
      COMMON /BELA/  KNBE(70),NULA(70),BELAST(70,6)
      COMMON /PAR/   KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *               LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
      COMMON /CHAR/  NAME(6) , NARA(50,6)
      DATA DRU,TYP,NT,JA  /'*DRU','*TYP','T','J'/
      OPEN (5,FILE=' ',STATUS='OLD',ACCESS='SEQUENTIAL'
     *         ,FORM='FORMATTED')
      OPEN (6,FILE='LPT1',STATUS='NEW')
      LAD = 6105
      LAX=  500
      LAV = 500
C
C             EINLESEN DES *DRUCK-BEFEHLS
C
      READ(5,1,END=140) BEF,RELE,AUST,AUVE,AUSP,AULA,PLOT
1     FORMAT(A4,2X,6(6X,A1))
      IF(BEF.EQ.DRU) GOTO 100
C
      WRITE(6,2)
2     FORMAT(1H0,'*DRUCK-BEFEHL FALSCH ODER NICHT 1. SATZ')
      STOP
C
C            EINLESEN DES *TYPEN-BEFEHLS
C
100   READ(5,3,END=140) BEF,KOANZ,FREI,ANZA,(ETYP(J),J=1,2)
     *                 ,(NAME(J),J=1,FREI)
3     FORMAT(A4,3X,3(6X,I1),6X,2F2.0,7X,6A2)
      IF (BEF.EQ.TYP) GOTO 150
C
      WRITE(6,5)
5     FORMAT(1H0,'*TYP-BEFEHL FALSCH ODER NICHT 2.SATZ')
      STOP
C
140   WRITE(6,7)
7     FORMAT(1H0,'BEFEHLE FEHLEN ODER SIND FALSCH')
      STOP
C
C           *****************************
C           ***   AUFRUF UP EINGAB    ***
C           *****************************
C
150   CLOSE (5,STATUS='KEEP')
      WRITE (*,'(1H ,''EINGAB'')')
      CALL  EINGAB  (KFEHL,AUST,NLAFA,NBE,NSOLL)
      CLOSE (50,STATUS='KEEP')
C
C        PRUEFEN, OB DIE BANDBREITE DER STRUKTUR
C        KLEINER ALS DIE VOM PROGRAMM FESTGELEGTE
C        UND DIE LAENGE DER GS-MATRIX KLEINER ALS
C        DIE IM PROGRAMM FESTGELEGTE LAENGE IST
C
      MBA = -0.5 + (0.25 + 2*LAD)**0.5
      WRITE (6,8) MBAND,LGS,MBA,LAV
8     FORMAT (/1H0,20X,'DIE BANDBREITE DER STRUKTUR IST ',I5,/
     *     1H ,20X,'DIE LAENGE DER GS-MATRIX IST ',I5,/
     *     1H ,20X,'DIE IM PROGRAMM FESTGELEGTEN GRENZEN SIND:',/
     *     1H ,20X,'BANDBREITE = ',I5,
     *     ', LAENGE DER GS-MATRIX = ',I5)
      IF (MBAND.LE.MBA.AND.LGS.LE.LAV) GOTO 160
      WRITE(6,10)
10    FORMAT(1H ,'IHRE STRUKTUR KANN NICHT BERECHNET WERDEN')
      STOP
C
160   IF(KFEHL.EQ.1.OR.RELE.EQ.NT) STOP
C           ********************************
C           ***  AUFRUF UP GESAMT  *********
C           ********************************
C
      WRITE (*,'(1H ,''GESAMT'')')
      CALL GESAMT
C
C           ********************************
C           *** AUFRUF UP RAND  ************
C           ********************************
C
      WRITE (*,'(1H ,''RAND'')')
      CALL RAND1 (AULA)
C
C           ********************************
C           ****   AUFRUF UP CHOLBA  *******
C           ********************************
C
      WRITE (*,'(1H ,''CHOLBA'')')
      CALL CHOLBA
C
C   ***************************************************
C   *  DO-SCHLEIFE UEBER DIE VERSCHIEDENEN LASTFAELLE *
C   ***************************************************
C
      DO 200   LF=1,NLAFA
      WRITE (6,9) LF
9     FORMAT (1H0,25X,24(1H*)/
     *        1H ,25X,'*ERGEBNISSE LASTFALL ',I2,'*'/
     *        1H ,25X,24(1H*))
C
      WRITE (*,'(1H ,''BELA'')')
      CALL BELA1 (LF,NBE,NSOLL)
C
      WRITE (*,'(1H ,''VORRUE'')')
      CALL VORRUE
C
      IF (LF .EQ. NLAFA) CLOSE (70,STATUS='DELETE')
C
      IF (AUVE .EQ. JA) CALL AUSVER (LF,PLOT)
C
      IF (AUSP .EQ. JA) CALL AUSSPA(LF)
C
      IF (AULA .EQ. JA) CALL AUFLAG(LF)
C
200   CONTINUE
      CLOSE (80,STATUS='DELETE')
      CLOSE (52,STATUS='DELETE')
      STOP
      END
