C    *************************
C    *************************
C    *** UNTERPROGRAMM SPA1***
C    *************************
C    *************************
C    DAS UNTERPROGRAMM SPA1 ERMITTELT DIE SPANNNUNGEN
C    UND DEHNUNGEN IM DREIECKSELEMENT UND DRUCKT SIE
C*********************************************
C*    VERWENDETE VARIABLEN                   *
C*                                           *
C*    E        :ELASTIZITAETSMODUL           *
C*    Q        :QUERZAHL                     *
C*    FL       :FLAECHENINHALT DES DREIECKES *
C*    DA-DF    :KOORDINATENDIFFERENZEN       *
C*    SIGMA XX :NORMALSPANNUNG IN X-RICHTUNG *
C*    SIGMA YY :NORMALSPANNUNG IN Y-RICHTUNG *
C*    TAU XY   :SCHUBSPANNUNG                *
C*                                           *
C*    VERWENDETE FELDER                      *
C*                                           *
C*    S        :SPANNUNGSMATRIX              *
C*    X        :KNOTENKOORDINATEN DES VER-   *
C*              WENDETEN DREIECKS            *
C*    V        :VERSCHIEBUNGSVEKTOR          *
C*********************************************
      SUBROUTINE SPA1 (I1,I4,X,E,Q)
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER       FREI,ANZA
      DIMENSION        X(3,3),I4(3),S(3,6),Z(3)
C
      COMMON /FELD/ A(110),D(6105),V(500),XKN(500)
      COMMON /PAR/  KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *              LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
      DO 5  K = 1,3
      Z ( K ) = 0.
5     CONTINUE
      DA=X(3,2)-X(2,2)
      DB=X(3,1)-X(2,1)
      DC=X(1,2)-X(3,2)
      DD=X(1,1)-X(3,1)
      DE=X(2,2)-X(1,2)
      DF=X(2,1)-X(1,1)
C
C         FLAECHENINHALT DES DREIECKS
C
      FL=0.5*(DF*DA-DB*DE)
C
      F=(1.-Q)/2.
C
C          SPANNUNGSMATRIX
C
      S(1,1)=-DA
      S(1,2)=DB*Q
      S(1,3)=-DC
      S(1,4)=DD*Q
      S(1,5)=-DE
      S(1,6)=DF*Q
      S(2,1)=S(1,1)*Q
      S(2,2)=S(1,2)/Q
      S(2,3)=S(1,3)*Q
      S(2,4)=S(1,4)/Q
      S(2,5)=S(1,5)*Q
      S(2,6)=S(1,6)/Q
      S(3,1)=DB*F
      S(3,2)=-DA*F
      S(3,3)=DD*F
      S(3,4)=-DC*F
      S(3,5)=DF*F
      S(3,6)=-DE*F
C
      B=E/((1.-Q**2)*2.*FL)
C
C     BERECHNUNG DES SPANNUNGSVEKTORS
C
      DO 10 I=1,2
      DO 10 J=2,6,2
      DO 10 K=1,3
      J1=J+I-2
      J2=(I4(J/2)-1)*FREI+I
      Z(K)=Z(K)+S(K,J1)*V(J2)
10    CONTINUE
C
      SIGXX=Z(1)*B
      SIGYY=Z(2)*B
      TAUXY=Z(3)*B
C
C           DRUCKEN
C
      WRITE (6,1) I1,SIGXX,SIGYY,TAUXY
1     FORMAT (1H ,3X,I5,10X,'SIGMAXX= ',F7.2,
     *'  SIGMAYY= ',F7.2,'  TAUXY= ',F7.2)
      RETURN
      END
