C  *******************************
C  *******************************
C  ***   UNTERPROGRAMM VORRUE ****
C  *******************************
C  *******************************
C  DAS UNTERPROGRAMM VORRUE ERMITTELT DIE VERSCHIEBUNGEN
C  DURCH VOR- UND RUECKWAERTSEINSETZEN IN DIE MATRIX R
C************************************************************
C*    VERWENDETE VARIABLEN                                  *
C*                                                          *
C*    NZ    : ZEILE AUS DER RECHTSMATRIX                    *
C*                                                          *
C*    VERWENDETE FELDER                                     *
C*                                                          *
C*    D     : "DREIECKSMATRIX", MIT DER BEIM VORWAERTS-     *
C*            EINSETZEN DIE ZWISCHENLOESUNG BERECHNET WIRD  *
C*    V     : VERSCHIEBUNGSVEKTOR, ENTHAELT NACH VORWAERTS- *
C*            EINSETZEN DIE ZWISCHENLOESUNG, NACH DEM       *
C*            RUECKWAERTSEINSETZEN DIE VERSCHIEBUNGEN       *
C************************************************************
      SUBROUTINE VORRUE 
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER      FREI,ANZA
      COMMON /FELD/  A(110),D(6105),V(500),XKN(500)
      COMMON /PAR/   KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *               LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
C
C              ANFANGS- UND ENDADRESSE DER
C              UNTERSTEN ZEILE DES "DREIECKS"
C
      LD = MBAND*(MBAND + 1)/2
      ND= MBAND - 1
      L = LD - ND
C              ****************************
C              *** VORWAERTSEINSETZEN  ****
C              ****************************
      DO 500 NZ = 1,LGS
C
C              AKTUALISIEREN DES "DREIECKS" UND
C              LESEN EINER ZEILE AUS DER DATEI '70'
C
      CALL DORG (NZ,L,LD,ND,0)
C
C              BERECHNEN DER NZ. KOMPONENTE
C              DER ZWISCHENLOESUNG
C
      DO 400 J = 1,ND
      NA = J*(J-1)/2 + 1
      NB = NZ - MBAND + J
      IF (NB.LE.0) GOTO 400
      V(NZ) = V(NZ) - D(NA)*V(NB)
400   CONTINUE
      V(NZ) = V(NZ)/D(L)
500   CONTINUE
C
C              *****************************
C              *** RUECKWAERTSEINSETZEN ****
C              *****************************
C
      DO 800 N = 1,LGS
C
C                LESEN DER SAETZE AUS DER
C                DATEI '70' VON HINTEN
C
      NZ = LGS - N + 1
      READ(70,REC=NZ) (D(I) , I = L,LD)
C
C                BERECHNEN DER NZ. KOMPONENTE
C                DES LOESUNGSVEKTORS
C
      DO 600 J = 1,ND
      NA = L + J
      NB = NZ + J
      IF (NB.GT.LGS) GOTO 600
      V(NZ) = V(NZ) - D(NA)*V(NB)
600   CONTINUE
      V(NZ) = V(NZ)/D(L)
800   CONTINUE
      RETURN
      END
